// Copyright (C) 2025 Johannes Knödtel
// Full notice in 'LICENSE'

#pragma once

#include <limits.h>
#include <stdint.h>

typedef struct
{
    uint32_t h;
    uint32_t len;
} hashDesc;

// largest Prime below 2^64
#define PRIME 4294967291u

// default base
#define BASE 255

#define HASH_INITIAL 0x0

uint32_t power_of_base(int pow);
void hash_roll_poly2(int length, char signs[], hashDesc *results);
void hash_drop_prefix_poly2(hashDesc *hashArr, char signs[], int index, hashDesc *results);
void hash_drop_suffix_poly2(hashDesc *hashArr, char signs[], int index, hashDesc *results);
