# Copyright (C) 2025 Johannes Knödtel
# Full notice in 'LICENSE'

from ctypes import CDLL, c_int, c_char_p, c_size_t, c_void_p

librepetition = CDLL('librepetition.so')
librepetition.initRepNode.restype = c_void_p
librepetition.initRepNode.argtypes = (c_int,)
librepetition.detect_repetitions.argtypes = (c_void_p, c_char_p, c_size_t)

def detect_repetitions_cimpl(inp: bytes):
    rn = librepetition.initRepNode(0)
    librepetition.detect_repetitions(rn, inp, len(inp))
    return rn

def print_rep_node(rn):
    librepetition.printRepNode(c_void_p(rn))